<?php
/*
 * $Id: desktopcontrolHandler.php,v 1.1.2.2 2002/01/12 02:38:59 pbaltz Exp $
 * Copyright 2001, 2002 Sun Microsystems, Inc.  All rights reserved.
 */

include_once("ServerScriptHelper.php");
include_once("Error.php");

$helper = new ServerScriptHelper();
$cce = $helper->getCceClient();
$errors = array();
$lock_script = '/usr/sausalito/sbin/cce_lock.pl';

if ($lock_desktop) {
	/*
	 * We are attempting to lock the desktop.  First, get the current
	 * state for rollback
	 */
	$sysobj = $cce->getObject('System', array(), 'DesktopControl');

	# Set the lock state in CCE
	$cce->setObject('System', array('lock' => $lock_desktop),
			'DesktopControl');

	/*
	 * If the desktop is already locked, the above will fail.  Let it.
	 * It is probably a race with the command line too and there is nothing
	 * we should do about it here or we may interfere with a backup or 
	 * some such.
	 */
	$errors = $cce->errors();
	if (count($errors) == 0) {
		/*
		 * We successfully set the lock bit.  Now actually lock the
		 * desktop by running a cce wrapped script as root.
		 */
		$lock_cmd = "$lock_script --lock --reason=[[base-backupcontrol.locked]]";
		$ret = $helper->shell($lock_cmd, $output, 'root');

		if ($ret != 0) {
			# Suspending failed.  Rollback the lock bit.
			$cce->setObject('System', array('lock' => $sysobj['lock']),
			    'DesktopControl');
			array_merge($errors, $cce->errors()); 
		}				
	}
} else {
	// We are attempting to unlock the desktop.  Unlock cce first.
	$ret = $helper->shell("$lock_script --unlock", $output, 'root');

	if ($ret == 0) {
		// Try to unset the lock bit.
		$cce->setObject('System', array('lock' => $lock_desktop),
				'DesktopControl');
		array_merge($errors, $cce->errors()); 
	}
}

// Return to the calling page and process errors.
print($helper->toHandlerHtml('/base/backupcontrol/desktopcontrol.php', $errors,
			     false));

$helper->destructor();
?>
